<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
<!-- project.qdoc -->
  <title>Project QML Type | Qbs Manual</title>
  <link rel="stylesheet" type="text/css" href="style/offline-simple.css" />
  <script type="text/javascript">
    document.getElementsByTagName("link").item(0).setAttribute("href", "style/offline.css");
    // loading style sheet breaks anchors that were jumped to before
    // so force jumping to anchor again
    setTimeout(function() {
        var anchor = location.hash;
        // need to jump to different anchor first (e.g. none)
        location.hash = "#";
        setTimeout(function() {
            location.hash = anchor;
        }, 0);
    }, 0);
  </script>
</head>
<body>
<div class="header" id="qtdocheader">
  <div class="main">
    <div class="main-rounded">
      <div class="navigationbar">
        <table><tr>
<td ><a href="index.html">Qbs Manual</a></td></tr></table><table class="buildversion"><tr>
<td id="buildversion" width="100%" align="right">Qbs 1.15.0</td>
        </tr></table>
      </div>
    </div>
<div class="content">
<div class="line">
<div class="content mainContent">
  <link rel="prev" href="qml-qbslanguageitems-profile.html" />
  <link rel="next" href="qml-qbslanguageitems-properties.html" />
<p class="naviNextPrevious headerNavi">
<a class="prevPage" href="qml-qbslanguageitems-profile.html">Profile</a>
<span class="naviSeparator">  &#9702;  </span>
<a class="nextPage" href="qml-qbslanguageitems-properties.html">Properties</a>
</p><p/>
<div class="sidebar">
<div class="toc">
<h3><a name="toc">Contents</a></h3>
<ul>
<li class="level1"><a href="#properties">Properties</a></li>
<li class="level1"><a href="#details">Detailed Description</a></li>
</ul>
</div>
<div class="sidebar-content" id="sidebar-content"></div></div>
<h1 class="title">Project QML Type</h1>
<span class="subtitle"></span>
<!-- $$$Project-brief -->
<p>Represents a collection of products and properties. <a href="#details">More...</a></p>
<!-- @@@Project -->
<div class="table"><table class="alignedsummary">
<tr><td class="memItemLeft rightAlign topAlign"> Import Statement:</td><td class="memItemRight bottomAlign"> import QbsLanguageItems .</td></tr></table></div><ul>
<li><a href="qml-qbslanguageitems-project-members.html">List of all members, including inherited members</a></li>
</ul>
<a name="properties"></a>
<h2 id="properties">Properties</h2>
<ul>
<li class="fn"><b><b><a href="qml-qbslanguageitems-project.html#buildDirectory-prop">buildDirectory</a></b></b> : path</li>
<li class="fn"><b><b><a href="qml-qbslanguageitems-project.html#condition-prop">condition</a></b></b> : bool</li>
<li class="fn"><b><b><a href="qml-qbslanguageitems-project.html#minimumQbsVersion-prop">minimumQbsVersion</a></b></b> : string</li>
<li class="fn"><b><b><a href="qml-qbslanguageitems-project.html#name-prop">name</a></b></b> : string</li>
<li class="fn"><b><b><a href="qml-qbslanguageitems-project.html#profile-prop">profile</a></b></b> : string</li>
<li class="fn"><b><b><a href="qml-qbslanguageitems-project.html#qbsSearchPaths-prop">qbsSearchPaths</a></b></b> : stringList</li>
<li class="fn"><b><b><a href="qml-qbslanguageitems-project.html#references-prop">references</a></b></b> : pathList</li>
<li class="fn"><b><b><a href="qml-qbslanguageitems-project.html#sourceDirectory-prop">sourceDirectory</a></b></b> : path</li>
</ul>
<!-- $$$Project-description -->
<a name="details"></a>
<h2 id="details">Detailed Description</h2>
<p>A Project item represents a collection of of products. In a non-trivial project, these products are typically defined in their own files and referenced in the main project file:</p>
<pre class="cpp">

  Project {
      references: <span class="operator">[</span>
          <span class="string">&quot;product1/product1.qbs&quot;</span><span class="operator">,</span>
          <span class="string">&quot;product2/product2.qbs&quot;</span>
      <span class="operator">]</span>
  }

</pre>
<p>Any property <code>prop</code> attached to this item is available in sub-items as <code>project.prop</code>.</p>
<p>While the root of the item hierarchy is always a Project, this kind of item can also appear further down the hierarchy. Such sub-projects are usually introduced to group products. See <a href="qml-qbslanguageitems-subproject.html">SubProject</a> for details.</p>
<p><b>Note: </b>If your project consists of only one product, the Project item can be omitted.</p><!-- @@@Project -->
<h2>Property Documentation</h2>
<!-- $$$buildDirectory -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="buildDirectory-prop">
<td class="tblQmlPropNode"><p>
<span class="qmlreadonly">[read-only] </span><span class="name">buildDirectory</span> : <span class="type">path</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>The build directory of the top-level project.</p>
</div></div><!-- @@@buildDirectory -->
<br/>
<!-- $$$condition -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="condition-prop">
<td class="tblQmlPropNode"><p>
<span class="name">condition</span> : <span class="type">bool</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>Whether the project is enabled. If <code>false</code>, no <a href="qml-qbslanguageitems-product.html">products</a> or sub-projects will be collected.</p>
<p>Default: <code>true</code></p>
</div></div><!-- @@@condition -->
<br/>
<!-- $$$minimumQbsVersion -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="minimumQbsVersion-prop">
<td class="tblQmlPropNode"><p>
<span class="name">minimumQbsVersion</span> : <span class="type">string</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>The minimum version of Qbs that is needed to build this project.</p>
<p>Default: <code>&quot;1.3&#x2e;0&quot;</code></p>
</div></div><!-- @@@minimumQbsVersion -->
<br/>
<!-- $$$name -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="name-prop">
<td class="tblQmlPropNode"><p>
<span class="name">name</span> : <span class="type">string</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>The project name. Only relevant when displaying a project tree in an IDE, for example.</p>
<p>Default: The basename of the file that defines the project.</p>
</div></div><!-- @@@name -->
<br/>
<!-- $$$profile -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="profile-prop">
<td class="tblQmlPropNode"><p>
<span class="qmlreadonly">[read-only] </span><span class="name">profile</span> : <span class="type">string</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>The top-level <a href="qml-qbslanguageitems-profile.html">profile</a> for building the project. This property is set by Qbs when the project is being set up.</p>
</div></div><!-- @@@profile -->
<br/>
<!-- $$$qbsSearchPaths -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="qbsSearchPaths-prop">
<td class="tblQmlPropNode"><p>
<span class="name">qbsSearchPaths</span> : <span class="type">stringList</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>A list of paths that are searched for imports and modules in addition to the ones listed in <code>preferences.qbsSearchPaths</code>. The value set here is merged with the value inherited from the parent project, if there is one. The result is inherited by all products in the project.</p>
<p>Default: An empty list</p>
</div></div><!-- @@@qbsSearchPaths -->
<br/>
<!-- $$$references -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="references-prop">
<td class="tblQmlPropNode"><p>
<span class="name">references</span> : <span class="type">pathList</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>A list of files from which to import products. This is equivalent to defining the respective <a href="qml-qbslanguageitems-product.html">Product</a> items directly under this Project item.</p>
<p>Default: An empty list</p>
</div></div><!-- @@@references -->
<br/>
<!-- $$$sourceDirectory -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="sourceDirectory-prop">
<td class="tblQmlPropNode"><p>
<span class="qmlreadonly">[read-only] </span><span class="name">sourceDirectory</span> : <span class="type">path</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>The directory where the file containing the top-level Project item is located.</p>
</div></div><!-- @@@sourceDirectory -->
<br/>
<p class="naviNextPrevious footerNavi">
<a class="prevPage" href="qml-qbslanguageitems-profile.html">Profile</a>
<span class="naviSeparator">  &#9702;  </span>
<a class="nextPage" href="qml-qbslanguageitems-properties.html">Properties</a>
</p>
        </div>
       </div>
   </div>
   </div>
</div>
<div class="footer">
   <p>
   <acronym title="Copyright">&copy;</acronym> 2020 The Qt Company Ltd.
   Documentation contributions included herein are the copyrights of
   their respective owners.<br/>    The documentation provided herein is licensed under the terms of the    <a href="http://www.gnu.org/licenses/fdl.html">GNU Free Documentation    License version 1.3</a> as published by the Free Software Foundation.<br/>    Qt and respective logos are trademarks of The Qt Company Ltd.     in Finland and/or other countries worldwide. All other trademarks are property
   of their respective owners. </p>
</div>
</body>
</html>
